#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 1010;
const int M = 12;
const int S = (1 << M) + 3;
const int B = 17;
const int K = 4;
int n, m;
int a[M][N];
int xs[M * M];
int k;
int cnt[N];
int curSz[M];
int p[M];
int b[M];
int lowest[S];
int prec[M][K][(1 << B) + 3];
bool ans[M * M];

struct Bitset {
	int w[K];

	Bitset() : w() {}

	void change(int p) {
		w[p / B] ^= 1 << (p % B);
	}
	int get(int p) {
		return (w[p / B] >> (p % B)) & 1;
	}
};

int getUnused(int id, Bitset C) {
	int mask = (1 << curSz[id]) - 1;
	for (int i = 0; i < K; i++)
		mask ^= prec[id][i][C.w[i]];
	return a[id][lowest[mask]];
}

void read() {
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			scanf("%d", &a[i][j]);
		}
		curSz[i] = m;
		for (int j = 0; j < m; j++)
			cnt[a[i][j]]++;
	}
	bool ch = true;
	while(ch) {
		ch = false;
		for (int i = 0; i < m; i++) {
			int q = 0;
			while(q < curSz[i] && cnt[a[i][q]] > 1) q++;
			q++;
			if (q >= curSz[i]) continue;
			ch = true;
			while(curSz[i] > q) {
				curSz[i]--;
				cnt[a[i][curSz[i]]]--;
			}
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < curSz[i]; j++)
			xs[k++] = a[i][j];
	}
	sort(xs, xs + k);
	k = unique(xs, xs + k) - xs;
	for (int i = 0; i < m; i++)
		for (int j = 0; j < curSz[i]; j++)
			a[i][j] = lower_bound(xs, xs + k, a[i][j]) - xs;
	assert(k <= m * (m + 1) / 2);
	for (int id = 0; id < m; id++) {
		for (int i = 0; i < curSz[id]; i++) {
			int x = a[id][i] / B;
			int y = a[id][i] % B;
			for (int mask = 0; mask < (1 << B); mask++)
				if ((mask >> y) & 1)
				prec[id][x][mask] ^= 1 << i;
		}
	}
}

void brute(int mask, Bitset used) {
	if (mask == 0) {
		return;
	}
	int cur = mask;
	while(cur > 0) {
		int q = lowest[cur];
		cur ^= 1 << q;
		int z = getUnused(q, used);
		used.change(z);
		ans[z] = 1;
		brute(mask ^ (1 << q), used);
		used.change(z);
	}
}

int main()
{
	startTime = clock();
//	freopen("seating.in", "r", stdin);
//	freopen("seating.out", "w", stdout);

	read();
	for (int mask = 1; mask < S; mask++) {
		lowest[mask] = 0;
		while(((mask >> lowest[mask]) & 1) == 0) lowest[mask]++;
	}

	brute((1 << m) - 1, Bitset());

	vector<int> res;
	for (int i = 0; i < k; i++)
		if (ans[i])
			res.push_back(xs[i]);
	sort(all(res));
	printf("%d\n", (int)res.size());
	for (int x : res)
		printf("%d ", x);
	printf("\n");

	return 0;
}
