#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 22;
const int M = (1 << N) + 5;
int n;
int a[N];
ld b[N], c[N];
ld dp[M];

ld solve(int m) {
	if (b[m - 1] <= c[m - 1]) return b[m - 1];
	ld sumP = 0;
	ld sumDer = 1. / (b[m - 1] - c[m - 1]);
	for (int i = m - 2; i >= 0; i--) {
		ld delta = b[i + 1] - b[i];
		ld z = sumDer * delta;
		if (sumP + z > 1) {
			return b[i + 1] - (1 - sumP) / sumDer;
		}
		sumP += z;
		if (b[i] <= c[i]) {
			return b[i];
		}
		sumDer += 1. / (b[i] - c[i]);
	}
	return b[0] - (1 - sumP) / sumDer;
}

int main()
{
	startTime = clock();
//	freopen("seating.in", "r", stdin);
//	freopen("seating.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);
	sort(a, a + n);
	for (int mask = 1; mask < (1 << n); mask++) {
		int m = 0;
		for (int i = 0; i < n; i++) {
			if (((mask >> i) & 1) == 0) continue;
			b[m] = a[i];
			c[m] = dp[mask ^ (1 << i)];
			assert(m == 0 || c[m] <= c[m - 1] + 1e-9);
			m++;
		}
		assert(c[m - 1] <= b[m - 1] + 1e-9);
		dp[mask] = solve(m);
	}
	printf("%.13lf\n", (double)dp[(1 << n) - 1]);

	return 0;
}
// 831669480.2821692228317