#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 3030;
vector<int> g[N];
int mt[N];
bool used[N];
bool hv[N];

void addToGraph(int k, ll m) {
	for (int x = 1; x < k; x++)
		if ((m + 1 - k) % x == 0) {
//			eprintf("edge %d %d\n", x - 1, k - 1);
			g[x - 1].push_back(k - 1);
		}
//	eprintf("edge %d %d\n", k - 1, (int)(m % k));
	g[k - 1].push_back(m % k);
}

bool dfs(int x) {
	if (used[x]) return false;
	used[x] = 1;
	for (int y : g[x]) {
		if (mt[y] == -1) {
			mt[y] = x;
			return true;
		}
	}
	for (int y : g[x]) {
		if (dfs(mt[y])) {
			mt[y] = x;
			return true;
		}
	}
	return false;
}

int kuhn(int n) {
	int ans = 0;
	while(true) {
		for (int i = 0; i < n; i++)
			used[i] = 0;
		bool fnd = false;
		for (int x = 0; !fnd && x < n; x++) {
			if (used[x] || hv[x]) continue;
			if (dfs(x)) {
				hv[x] = 1;
				fnd = true;
				ans++;
			}
		}
		if (!fnd) return ans;
	}
}

vector<int> solve(ll m) {
//	eprintf("solve %lld\n", m);
	for (int i = 0; i < N; i++) {
		g[i].clear();
		mt[i] = -1;
		used[i] = 0;
		hv[i] = 0;
	}
	vector<int> ans = {1};
	int mtSz = 0;
	for (int k = 1; k < N && 2 * k <= m; k++) {
		addToGraph(k, m);
		mtSz += kuhn(k);
		ans.push_back((int)(mtSz == k));
	}
	while(ans.back() == 0) ans.pop_back();
	return ans;
}

void printAns(vector<int> ans, ll m) {
	if ((int)ans.size() * 2 > m) {
		vector<int> res = ans;
		while((int)res.size() < m + 1) {
			int k = m - (int)res.size();
			res.push_back(ans[k]);
		}
		printf("2\n");
		printf("%d", (int)res.size());
		for (int x : res)
			printf(" %d", x);
		printf("\n");
		return;
	}
	printf("100\n");
	for (int i = 2; i < 100; i++) {
		int x = (i == 2 ? 0 : i - 1);
		printf("2 %d %d\n", x, x);
	}
	vector<int> res = ans;
	m -= (int)ans.size() * 2 - 1;
	for (int k = 0; m > 0; k++) {
		if (m & 1) {
			int x = (k == 0 ? 0 : k + 1);
			res.push_back(x);
		}
		m >>= 1;
	}
	reverse(all(ans));
	for (int x : ans) res.push_back(x);
	printf("%d", (int)res.size());
	for (int x : res)
		printf(" %d", x);
	printf("\n");
}

int main()
{
//	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
/*
	while(true) {
		ll x = myRand(1e18) + 1;
		vector<int> ans = solve(x);
		if ((int)ans.size() > 29) {
			eprintf("%lld %d\n", x, (int)ans.size());
		}
	}
*/
/*
	int mx = 0;
	for (int i = 1; i < 10000000; i++) {
		if (i % 10000 == 0) {
			eprintf("try %d\n", i);
		}
		vector<int> ans = solve(i);
		if ((int)ans.size() > mx) {
			mx = (int)ans.size();
			eprintf("new best %d %d\n", i, mx);
		}
		
	}
*/

	ll m;
	scanf("%lld", &m);
	vector<int> ans = solve(m);
	printAns(ans, m);

	return 0;
}
