#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 20005;
const int M = 120;
int LST = 0;
int n;
int a[N];
vector<int> ans[M];

void solve(int L, int R, int S) {
	assert(S < M);
	if (L >= R) return;
	if (L + 1 == R) {
		LST = max(LST, S);
		while(S < M) {
			ans[S].push_back(1);
			S++;
		}
		return;
	}
	int Z = (L + R) / 2;
	vector<pii> b;
	b.push_back(mp(0, 0));
	for (int i = L; i < R; i++) {
		int c = 0;
		if (a[i] < Z) {
			c = 0;
		} else {
			c = 1;
		}
		if (b.back().first == c) {
			b.back().second++;
		} else {
			b.push_back(mp(c, 1));
		}
	}
	while(true) {
		int sz = (int)b.size();
		if (sz >= 2 && (sz & (sz - 1)) == 0) break;
		b.push_back(mp(sz & 1, 0));
	}
	while((int)b.size() > 2) {
		assert((int)b.size() % 4 == 0);
		int pos = L;
		vector<pii> nb;
		for (int i = 0; i < (int)b.size(); i += 4) {
			assert(b[i].first == 0);
			assert(b[i + 1].first == 1);
			assert(b[i + 2].first == 0);
			assert(b[i + 3].first == 1);
			reverse(a + pos, a + pos + b[i].second);
			ans[S].push_back(b[i].second);
			pos += b[i].second;
			reverse(a + pos, a + pos + b[i + 1].second + b[i + 2].second);
			ans[S].push_back(b[i + 1].second + b[i + 2].second);
			pos += b[i + 1].second + b[i + 2].second;
			reverse(a + pos, a + pos + b[i + 3].second);
			ans[S].push_back(b[i + 3].second);
			pos += b[i + 3].second;
			nb.push_back(mp(0, b[i].second + b[i + 2].second));
			nb.push_back(mp(1, b[i + 1].second + b[i + 3].second));
		}
		b = nb;
		S++;
	}
	assert((int)b.size() == 2);
	solve(L, Z, S);
	solve(Z, R, S);
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
		a[i]--;
	}
	solve(0, n, 0);
	fprintf(stderr, "max queries = %d\n", LST);
	for (int i = 1; i < M; i += 2)
		reverse(all(ans[i]));
	for (int i = 0; i < M; i++) {
		vector<int> z;
		for (int x : ans[i])
			if (x != 0)
				z.push_back(x);
		ans[i] = z;
	}
	int cnt = 0;
	for (int i = 0; i < M; i++)
		if ((int)ans[i].size() >= 2)
			cnt++;
	printf("%d\n", cnt);
	for (int i = 0; i < M; i++)
		if ((int)ans[i].size() >= 2) {
			printf("%d", (int)ans[i].size());
			for (int x : ans[i])
				printf(" %d", x);
			printf("\n");
		}

	return 0;
}
