#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

ll gcd(ll x, ll y) {
	return (y == 0 ? x : gcd(y, x % y));
}

const int C = (int)1e6 + 1;
bool p[C];
int pr[C / 5];
int prSz;
int ANS = 0;
vector<pli> curPrimes;
ll curProd;
int lenProd;

ll mySqrt(ll x) {
	ll y = (ll)sqrtl((ld)x);
	while(y * y < x) y++;
	while(y * y > x) y--;
	if (y * y == x)
		return y;
	return -1;
}

const int IT = 60;
const ll B = 8;
ll mult(ll x, ll y, ll mod) {
	if (y == 0) return 0;
	return (mult((x * B) % mod, y / B, mod) + x * (y % B)) % mod;
}
ll bin_pow(ll x, ll p, ll mod) {
	if (p == 0) return 1;
	if (p & 1) return mult(bin_pow(x, p - 1, mod), x, mod);
	return bin_pow(mult(x, x, mod), p / 2, mod);
}

bool isProbablyPrime(ll x) {
	ll s = x - 1;
	int t = 0;
	while(s % 2 == 0) {
		s /= 2;
		t++;
	}
	for (int it = 0; it < IT; it++) {
		ll y = 2 + myRand(x - 2);
		y = bin_pow(y, s, x);
		if (y == 1) continue;
		bool ok = false;
		for (int i = 0; !ok && i < t; i++) {
			if (y == x - 1) {
				ok = true;
				break;
			}
			y = mult(y, y, x);
			if (y == 1) return false;
		}
		if (!ok) return false;
	}
	return true;
}

int main()
{
	startTime = clock();
//	freopen("seating.in", "r", stdin);
//	freopen("seating.out", "w", stdout);

	for (int i = 2; i < C; i++)
		p[i] = 1;
	for (int i = 2; i < C; i++) {
		if (!p[i]) continue;
		pr[prSz++] = i;
		for (int j = 2 * i; j < C; j += i)
			p[j] = 0;
	}
//	eprintf("prSz = %d\n", prSz);

	curProd = 1;

	int n;
	scanf("%d", &n);
	while(n--) {
		ll x;
		scanf("%lld", &x);
		ll g = gcd(x, curProd);
		if (g == 1) {
			curProd = 1;
			lenProd = 0;
		} else if (g == curProd) {
			lenProd++;
			x /= curProd;
			assert(gcd(x, curProd) == 1);
		} else {
			curPrimes.push_back(mp(g, lenProd));
			curPrimes.push_back(mp(curProd / g, lenProd));
			curProd = 1;
			lenProd = 0;
		}
		vector<pli> newPrimes;
		for (auto t : curPrimes) {
			ll q = t.first;
			if (x % q) {
				ANS ^= t.second;
				continue;
			}
			newPrimes.push_back(mp(q, t.second + 1));
			while(x % q == 0) x /= q;
		}
		for (int i = 0; i < prSz; i++) {
			if (x % pr[i]) continue;
			newPrimes.push_back(mp((ll)pr[i], 1));
			while(x % pr[i] == 0) x /= pr[i];
		}
		if (x != 1) {
			assert(lenProd == 0);
			ll y = mySqrt(x);
			if (y != -1) {
				newPrimes.push_back(mp(y, 1));
			} else if (isProbablyPrime(x)) {
				newPrimes.push_back(mp(x, 1));
			} else {
				curProd = x;
				lenProd = 1;
			}
		}
		curPrimes = newPrimes;
	}
	for (auto t : curPrimes)
		ANS ^= t.second;
	if (ANS)
		printf("First\n");
	else
		printf("Second\n");

	return 0;
}
