#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const double PI = 4 * atan(1.);

const int MAG = 1e7;
double getMiddle(ll n) {
	if (n < MAG) {
		double ans = 1;
		for (int k = 1; k <= n; k++) {
			ans *= (double)(2 * k) / (2 * k - 1);
		}
		return ans;
	} else {
		return sqrt(n * PI);
	}
}
double solve(ll A, ll B) {
	if (A > B) swap(A, B);
	double ans = getMiddle(A);
	for (ll k = A + 1; k <= B; k++) {
		ans *= 2.0 * k / (A + k);
		if (ans > 2e9) {
			eprintf("k = %lld\n", k);
			return ans;
		}
	}
	return ans;
}

int main()
{
	startTime = clock();
//	freopen("seating.in", "r", stdin);
//	freopen("seating.out", "w", stdout);

/*
	ll k = 1;
	while(k < MAG) {
		printf("%.10lf\n", getMiddle(k));
		printf("%.10lf\n", sqrt(k * PI));
		k <<= 1;
	}
*/

	ll A, B;
	scanf("%lld%lld", &A, &B);
	double ans = solve(A, B);
	if (ans > 1e9) {
		printf("Extreme Wealth\n");
	} else {
		printf("%.13lf\n", ans);
	}

	return 0;
}
