#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const ll MOD = (ll)1e18 + 31;
const ll G = 42;

const ll B = 8;
ll mult(ll x, ll y) {
	//return ((__int128)x * y) % MOD;
	if (y == 0) return 0;
	return (mult((x * B) % MOD, y / B) + (x * (y % B))) % MOD;
}
ll bin_pow(ll x, ll p) {
	if (p == 0) return 1;
	if (p & 1) return mult(x, bin_pow(x, p - 1));
	return bin_pow(mult(x, x), p / 2);
}

const int N = 40001;
ll a[4][N + 3];

vector<ll> getPrimes(ll x) {
	vector<ll> res;
	for (ll p = 2; p * p <= x; p++) {
		if (x % p) continue;
		res.push_back(p);
		while(x % p == 0) x /= p;
	}
	if (x > 1) res.push_back(x);
	return res;
}

ll getPow(ll p) {
	ll res = 1;
	for (int i = 0; p > 0; i++) {
		res = mult(res, a[i][p % N]);
		p /= N;
	}
	return res;
}

int main()
{
	startTime = clock();
//	freopen("seating.in", "r", stdin);
//	freopen("seating.out", "w", stdout);

/*
	vector<ll> pr = getPrimes(MOD - 1);
	for (ll g = 2; g < 1000; g++) {
		bool ok = true;
		for (ll p : pr)
			ok &= bin_pow(g, (MOD - 1) / p) != 1;
		if (ok) printf("%lld\n", g);
	}
*/

	a[0][0] = 1;
	a[0][1] = G;
	for (int k = 0; k < 4; k++) {
		a[k][0] = 1;
		if (k > 0) a[k][1] = a[k - 1][N];
		for (int i = 2; i <= N; i++) {
			a[k][i] = mult(a[k][i - 1], a[k][1]);
		}
	}

	ll x = 300;
	int n;
	scanf("%d", &n);
	for (int i = n; i < (int)1e6; i++) {
		if (i % (int)1e5 == 0) {
			eprintf("i = %d, x = %lld, time = %.3lf\n", i, x, getCurrentTime());
		}
		x = getPow(x);
	}
	printf("%lld\n", x);

	return 0;
}
